package beans;
import java.io.*;

public class FortuneTellingBean {
    private String name;
    private String mail;
    private String bloodType;
    private String contextRootPath;

    public FortuneTellingBean() {}
    public FortuneTellingBean(String name, String mail, String bloodType) {
        this.name = name;
        this.mail = mail;
        this.bloodType = bloodType;
    }

    public void setName(String name) { this.name = name; }
    public void setMail(String mail) { this.mail = mail; }
    public void setBloodType(String bloodType) { this.bloodType = bloodType; }  

    public String getName() { return name; }
    public String getResult() { return doFortuneTelling(); }
    public void setContextRootPath(String path) { contextRootPath = path; }

    public String doFortuneTelling() {
        writeReport();
        return seekResult();
    }

    private void writeReport() {
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter(contextRootPath + "report.txt", true));
            writer.write("name=" + name + "," + "mail=" + mail + "," + "bloodType=" + bloodType);
            writer.newLine();
            writer.flush();
            writer.close();
        }
        catch(IOException e) {
        }
    }

    private String seekResult() {
        try {
            BufferedReader reader = new BufferedReader(new FileReader(contextRootPath + "result.txt"));
            return StringToken(reader);
        }
        catch(IOException e) {
            return e.toString();
        }
    }

    private String StringToken(BufferedReader reader) {
        try {
            int current = 0;
            int token = 0;
            String line = reader.readLine();
            while(line != null) {
                if(line.length() > 0) {
                    token = line.indexOf("=");
                    String type = line.substring(current, token);
                    if(bloodType.compareTo(type) == 0) {
                        break;
                    }
                }
                line = reader.readLine();
            }
            current = line.indexOf("\"", token);
            token = line.indexOf("\"", ++current);
            return line.substring(current, token);
        }
        catch(IOException e) {
            return e.toString();
        }
    }
}